package org.apache.shardingsphere.encrypt.algorithm.standard;

package ..deTemp.1729592381552;

import com.google.common.base.Strings;
import java.nio.charset.StandardCharsets;
import java.security.GeneralSecurityException;
import java.util.Arrays;
import java.util.Base64;
import java.util.Properties;
import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import lombok.Generated;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.shardingsphere.encrypt.spi.EncryptAlgorithm;
import org.apache.shardingsphere.encrypt.spi.EncryptAlgorithmMetaData;
import org.apache.shardingsphere.infra.algorithm.core.ShardingSphereAlgorithm;
import org.apache.shardingsphere.infra.algorithm.core.context.AlgorithmSQLContext;
import org.apache.shardingsphere.infra.algorithm.core.exception.AlgorithmInitializationException;
import org.apache.shardingsphere.infra.exception.core.ShardingSpherePreconditions;

public final class AESEncryptAlgorithm implements EncryptAlgorithm {
  private static final String AES_KEY = "aes-key-value";
  
  private static final String DIGEST_ALGORITHM_NAME = "digest-algorithm-name";
  
  @Generated
  public boolean equals(Object o) {
    if (o == this)
      return true; 
    if (!(o instanceof org.apache.shardingsphere.encrypt.algorithm.standard.AESEncryptAlgorithm))
      return false; 
    org.apache.shardingsphere.encrypt.algorithm.standard.AESEncryptAlgorithm other = (org.apache.shardingsphere.encrypt.algorithm.standard.AESEncryptAlgorithm)o;
    Object this$metaData = getMetaData(), other$metaData = other.getMetaData();
    return ((this$metaData == null) ? (other$metaData != null) : !this$metaData.equals(other$metaData)) ? false : (!!Arrays.equals(this.secretKey, other.secretKey));
  }
  
  @Generated
  public int hashCode() {
    int PRIME = 59;
    result = 1;
    Object $metaData = getMetaData();
    result = result * 59 + (($metaData == null) ? 43 : $metaData.hashCode());
    return result * 59 + Arrays.hashCode(this.secretKey);
  }
  
  private final EncryptAlgorithmMetaData metaData = new EncryptAlgorithmMetaData(true, true, false);
  
  private byte[] secretKey;
  
  @Generated
  public EncryptAlgorithmMetaData getMetaData() {
    return this.metaData;
  }
  
  public void init(Properties props) {
    this.secretKey = getSecretKey(props);
  }
  
  private byte[] getSecretKey(Properties props) {
    String aesKey = props.getProperty("aes-key-value");
    ShardingSpherePreconditions.checkState(!Strings.isNullOrEmpty(aesKey), () -> new AlgorithmInitializationException((ShardingSphereAlgorithm)this, "%s can not be null or empty", new Object[] { "aes-key-value" }));
    String digestAlgorithm = props.getProperty("digest-algorithm-name", "SHA-1");
    return Arrays.copyOf(DigestUtils.getDigest(digestAlgorithm.toUpperCase()).digest(aesKey.getBytes(StandardCharsets.UTF_8)), 16);
  }
  
  public String encrypt(Object plainValue, AlgorithmSQLContext algorithmSQLContext) {
    try {
      if (null == plainValue)
        return null; 
      byte[] result = getCipher(1).doFinal(String.valueOf(plainValue).getBytes(StandardCharsets.UTF_8));
      return Base64.getEncoder().encodeToString(result);
    } catch (GeneralSecurityException $ex) {
      throw $ex;
    } 
  }
  
  public Object decrypt(Object cipherValue, AlgorithmSQLContext algorithmSQLContext) {
    try {
      if (null == cipherValue)
        return null; 
      byte[] result = getCipher(2).doFinal(Base64.getDecoder().decode(cipherValue.toString().trim()));
      return new String(result, StandardCharsets.UTF_8);
    } catch (GeneralSecurityException $ex) {
      throw $ex;
    } 
  }
  
  private Cipher getCipher(int decryptMode) throws GeneralSecurityException {
    Cipher result = Cipher.getInstance(getType());
    result.init(decryptMode, new SecretKeySpec(this.secretKey, getType()));
    return result;
  }
  
  public String getType() {
    return "AES";
  }
}
